# This file was generated by mettle.genes.db.GenPy3 [ver 2.1] on Tue Mar 22 16:49:01 2022
#

import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

class iCorrTypeAllowRegexForType(mettle.io.ISerializable):

    def __init__(self,
                 corrtype_id: str = '',
                 allow_id: str = '',
                 status: str = ''):
        """
        Constructor.

        :param corrtype_id: str
        :param allow_id: str
        :param status: str
        """
        self.corrtype_id = corrtype_id
        self.allow_id = allow_id
        self.status = status

    def clear(self):
        """
        Clears all member variables for this database record.
        """
        self.corrtype_id = ''
        self.allow_id = ''
        self.status = ''

    def _name(self) -> str:
        """
        Name of the record.

        :return: The name.
        """
        return 'iCorrTypeAllowRegexForType'

    def _serialize(self, _w: mettle.io.IWriter, _oname: str = None):
        """
        Serialize record to a stream.

        :param _w:
        :param _oname:
        """
        if _oname == None:
            _oname = self._name()

        _w.write_start(_oname)
        _w.write_string("corrtype_id", self.corrtype_id)
        _w.write_string("allow_id", self.allow_id)
        _w.write_char("status", self.status)
        _w.write_end(_oname)

    def _deserialize(self, _r: mettle.io.IReader, _oname: str = None):
        """
        Deserialize record from a stream.

        :param _r:
        :param _oname:
        """
        if _oname == None:
            _oname = self._name()

        _r.read_start(_oname)
        self.corrtype_id = _r.read_string("corrtype_id")
        self.allow_id = _r.read_string("allow_id")
        self.status = _r.read_char("status")
        _r.read_end(_oname)

    def _copy_from(self, rec: "iCorrTypeAllowRegexForType"):
        """
        Copies the column from the rec into this record.

        :param rec: The source record.
        """
        self.corrtype_id = rec.corrtype_id
        self.allow_id = rec.allow_id
        self.status = rec.status

    @staticmethod
    def _cache_davs(dvc=None):
        """
        Cache the DAV into the dav cache (or create one) and return it.

        :param dvc: (mettle.lib.DavCache), target cache, if None a new one is created and returned.
        """
        if dvc is None:
            dvc = mettle.lib.DavCache()

        dvc.add_targ("corrtype_id", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("corrtype_id", mettle.lib.Dav(mettle.lib.Dav.eDavType.Max, 16))
        dvc.add_targ("allow_id", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("allow_id", mettle.lib.Dav(mettle.lib.Dav.eDavType.Max, 32))
        dvc.add_targ("corrtype_id", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("corrtype_id", mettle.lib.Dav(mettle.lib.Dav.eDavType.Max, 16))
        dvc.add_targ("allow_id", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("allow_id", mettle.lib.Dav(mettle.lib.Dav.eDavType.Max, 32))
        dvc.add_targ("status", mettle.lib.Dav(mettle.lib.Dav.eDavType.Min, 1))
        dvc.add_targ("status", mettle.lib.Dav(mettle.lib.Dav.eDavType.Max, 1))
        dvc.add_targ("status", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("status", mettle.lib.Dav(mettle.lib.Dav.eDavType.In, ['A','D']))

        return dvc

    def _get_davs(self, dvc=None):
        iCorrTypeAllowRegexForType._cache_davs(dvc)

    def __repr__(self) -> str:
        return '<CorrTypeAllow [corrtype_id:%.32s, allow_id:%.32s, status:%.32s]>' % (
            self.corrtype_id, self.allow_id, self.status)


    class List(list, mettle.io.ISerializable):
        """
        List Class
        """

        def _name(self) -> str:
            """
            Name of the list.

            :return: The name
            """
            return 'iCorrTypeAllowRegexForType.List'

        def _serialize(self, _w: mettle.io.IWriter, _oname: str = None):
            """
            Serialize the list to a stream.

            :param _w:
            :param _oname:
            """
            if _oname == None:
                _oname = self._name()

            _w.write_start_list(_oname, len(self))

            for _rec in self:
                _rec._serialize(_w)

            _w.write_end(_oname)

        def _deserialize(self, _r: mettle.io.IReader, _oname: str = None):
            """
            Deserialize the list from a stream.

            :param _r:
            :param _oname:
            """
            if _oname == None:
                _oname = self._name()

            _cnt = _r.read_start_list(_oname)

            while _cnt >= 1:
                _rec  = iCorrTypeAllowRegexForType()
                _cnt -= 1
                _rec._deserialize(_r)
                self.append(_rec)

            _r.read_end(_oname)

        def __repr__(self) -> str:
            return '<iCorrTypeAllowRegexForType.List[%d]>' % (len(self))

        def _get_davs(self, dvc=None):
            return iCorrTypeAllowRegexForType._cache_davs(dvc)

