# This file was generated by mettle.genes.db.GenPy3 [ver 2.1] on Tue Mar 22 16:49:01 2022
#

import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from .no_templ_key import tNoTemplKey

class tNoTempl(mettle.io.ISerializable, mettle.db.IPrimaryKey):

    def __init__(self,
                 notype_id: str = '',
                 corrtype_id: str = '',
                 status: str = '',
                 lastcfg_id: int = 0,
                 templ: dict = None,
                 res_list: dict = None,
                 modified_by: str = ''):
        """
        Constructor.

        :param notype_id: str
        :param corrtype_id: str
        :param status: str
        :param lastcfg_id: int
        :param templ: dict
        :param res_list: dict
        :param modified_by: str
        :param tm_stamp: datetime.datetime
        """
        self.notype_id = notype_id
        self.corrtype_id = corrtype_id
        self.status = status
        self.lastcfg_id = lastcfg_id
        self.templ = templ
        self.res_list = res_list
        self.modified_by = modified_by
        self.tm_stamp = None

    def clear(self):
        """
        Clears all member variables for this database record.
        """
        self.notype_id = ''
        self.corrtype_id = ''
        self.status = ''
        self.lastcfg_id = 0
        self.templ = None
        self.res_list = None
        self.modified_by = ''
        self.tm_stamp = None

    def _name(self) -> str:
        """
        Name of the record.

        :return: The name.
        """
        return 'tNoTempl'

    def _serialize(self, _w: mettle.io.IWriter, _oname: str = None):
        """
        Serialize record to a stream.

        :param _w:
        :param _oname:
        """
        if _oname == None:
            _oname = self._name()

        _w.write_start(_oname)
        _w.write_string("notype_id", self.notype_id)
        _w.write_string("corrtype_id", self.corrtype_id)
        _w.write_char("status", self.status)
        _w.write_int64("lastcfg_id", self.lastcfg_id)
        _w.write_json("templ", self.templ)
        _w.write_json("res_list", self.res_list)
        _w.write_string("modified_by", self.modified_by)
        _w.write_datetime("tm_stamp", self.tm_stamp)
        _w.write_end(_oname)

    def _deserialize(self, _r: mettle.io.IReader, _oname: str = None):
        """
        Deserialize record from a stream.

        :param _r:
        :param _oname:
        """
        if _oname == None:
            _oname = self._name()

        _r.read_start(_oname)
        self.notype_id = _r.read_string("notype_id")
        self.corrtype_id = _r.read_string("corrtype_id")
        self.status = _r.read_char("status")
        self.lastcfg_id = _r.read_int64("lastcfg_id")
        self.templ = _r.read_json("templ")
        self.res_list = _r.read_json("res_list")
        self.modified_by = _r.read_string("modified_by")
        self.tm_stamp = _r.read_datetime("tm_stamp")
        _r.read_end(_oname)

    def _copy_from(self, rec: "tNoTempl"):
        """
        Copies the column from the rec into this record.

        :param rec: The source record.
        """
        self.notype_id = rec.notype_id
        self.corrtype_id = rec.corrtype_id
        self.status = rec.status
        self.lastcfg_id = rec.lastcfg_id
        self.templ = rec.templ
        self.res_list = rec.res_list
        self.modified_by = rec.modified_by
        self.tm_stamp = rec.tm_stamp

    def _write_pk(self, _key: "tNoTempl"):
        """
        Write the primary key columns to the key object.

        :param _key:
        """
        self._write_key(_key)

    def _read_pk(self, _key: "tNoTempl"):
        """
        Read the primary key columns from the key object.

        :param _key:
        """
        self._read_key(_key)

    def _serialize_key(self, _w: mettle.io.IWriter):
        """
        Serialize the primary key to a stream.

        :param _w:
        """
        _key = tNoTemplKey()

        self._write_key(_key)
        _key._serialize(_w)

    def _deserialize_key(self, _r: mettle.io.IReader):
        """
        Deserialize the primary key from a stream.

        :param _r:
        """
        _key = tNoTemplKey()

        _key._deserialize(_r)
        self._read_key(_key)

    @staticmethod
    def _cache_davs(dvc=None, for_ins: bool = False, key_only: bool = False):
        """
        Cache the DAV into the dav cache (or create one) and return it.

        :param dvc: (mettle.lib.DavCache), target cache, if None a new one is created and returned.
        :param for_ins: Davs for insert.
        :param key_only: Davs by key only, ie for delete/selectone.
        """
        if dvc is None:
            dvc = mettle.lib.DavCache()

        dvc.add_targ("notype_id", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("notype_id", mettle.lib.Dav(mettle.lib.Dav.eDavType.Max, 128))
        dvc.add_targ("corrtype_id", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("corrtype_id", mettle.lib.Dav(mettle.lib.Dav.eDavType.Max, 16))
        if key_only:
            return dvc

        dvc.add_targ("status", mettle.lib.Dav(mettle.lib.Dav.eDavType.Min, 1))
        dvc.add_targ("status", mettle.lib.Dav(mettle.lib.Dav.eDavType.Max, 1))
        dvc.add_targ("status", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("status", mettle.lib.Dav(mettle.lib.Dav.eDavType.In, ['A','D']))
        dvc.add_targ("templ", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("modified_by", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("modified_by", mettle.lib.Dav(mettle.lib.Dav.eDavType.Max, 128))

        return dvc

    def _get_davs(self, dvc=None, for_ins: bool = False, key_only: bool = False):
        tNoTempl._cache_davs(dvc, for_ins, key_only)

    def _write_key(self, _key: tNoTemplKey):
        """
        Write primary key columns to _key.

        :param _key:
        """
        _key.notype_id = self.notype_id
        _key.corrtype_id = self.corrtype_id

    def _read_key(self, _key: tNoTemplKey):
        """
        Read the primary key columns from _key.

        :param _key:
        """
        self.notype_id = _key.notype_id
        self.corrtype_id = _key.corrtype_id

    class Status_Couplet(dict):
        key_active = "A"
        key_disabled = "D"

        value_active = "Active"
        value_disabled = "Disabled"

        def __init__(self):
            self[self.key_active] = self.value_active
            self[self.key_disabled] = self.value_disabled

        @staticmethod
        def get_value(key):
            if key == tNoTempl.Status_Couplet.key_active:
                return tNoTempl.Status_Couplet.value_active

            if key == tNoTempl.Status_Couplet.key_disabled:
                return tNoTempl.Status_Couplet.value_disabled

            return ""

    @staticmethod
    def _pk_compare(x, y) -> int:
        """
        Compare function do primary key comparisons for list sorts and searches.

        :return: zero for x == y, negative for x < y, positive for x > y
        """
        rc = (x.notype_id > y.notype_id) - (x.notype_id < y.notype_id)

        if rc != 0:
            return rc

        rc = (x.corrtype_id > y.corrtype_id) - (x.corrtype_id < y.corrtype_id)

        return rc

    def __lt__(self, other):
        return other and self._pk_compare(self, other) < 0

    def __gt__(self, other):
        return other and self._pk_compare(self, other) > 0

    def __eq__(self, other):
        return other and self._pk_compare(self, other) == 0

    def __le__(self, other):
        return other and self._pk_compare(self, other) <= 0

    def __ge__(self, other):
        return other and self._pk_compare(self, other) >= 0

    def __ne__(self, other):
        return other == None or self._pk_compare(self, other)

    def __repr__(self) -> str:
        return '<NoTempl [notype_id:%.32s, corrtype_id:%.32s, status:%.32s, lastcfg_id:%r, templ:%.32s, res_list:%.32s, modified_by:%.32s, tm_stamp:%s]>' % (
            self.notype_id, self.corrtype_id, self.status, self.lastcfg_id, self.templ, self.res_list, self.modified_by, self.tm_stamp)


    class List(list, mettle.io.ISerializable):
        """
        List Class
        """

        def _name(self) -> str:
            """
            Name of the list.

            :return: The name
            """
            return 'tNoTempl.List'

        def _serialize(self, _w: mettle.io.IWriter, _oname: str = None):
            """
            Serialize the list to a stream.

            :param _w:
            :param _oname:
            """
            if _oname == None:
                _oname = self._name()

            _w.write_start_list(_oname, len(self))

            for _rec in self:
                _rec._serialize(_w)

            _w.write_end(_oname)

        def _deserialize(self, _r: mettle.io.IReader, _oname: str = None):
            """
            Deserialize the list from a stream.

            :param _r:
            :param _oname:
            """
            if _oname == None:
                _oname = self._name()

            _cnt = _r.read_start_list(_oname)

            while _cnt >= 1:
                _rec  = tNoTempl()
                _cnt -= 1
                _rec._deserialize(_r)
                self.append(_rec)

            _r.read_end(_oname)

        def __repr__(self) -> str:
            return '<tNoTempl.List[%d]>' % (len(self))

        def _get_davs(self, dvc=None, for_ins: bool = False, key_only: bool = False):
            return tNoTempl._cache_davs(dvc, for_ins, key_only)

