# This file was generated by mettle.genes.db.GenPy3 [ver 2.1] on Tue Mar 22 16:49:01 2022
#

import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

class oCorrProvForService(mettle.io.ISerializable):

    def __init__(self,
                 corrprov_id: str = '',
                 corrtype_id: str = '',
                 cfg: dict = None,
                 tm_stamp: datetime.datetime = None):
        """
        Constructor.

        :param corrprov_id: str
        :param corrtype_id: str
        :param cfg: dict
        :param tm_stamp: datetime.datetime
        """
        self.corrprov_id = corrprov_id
        self.corrtype_id = corrtype_id
        self.cfg = cfg
        self.tm_stamp = tm_stamp

    def clear(self):
        """
        Clears all member variables for this database record.
        """
        self.corrprov_id = ''
        self.corrtype_id = ''
        self.cfg = None
        self.tm_stamp = None

    def _name(self) -> str:
        """
        Name of the record.

        :return: The name.
        """
        return 'oCorrProvForService'

    def _serialize(self, _w: mettle.io.IWriter, _oname: str = None):
        """
        Serialize record to a stream.

        :param _w:
        :param _oname:
        """
        if _oname == None:
            _oname = self._name()

        _w.write_start(_oname)
        _w.write_string("corrprov_id", self.corrprov_id)
        _w.write_string("corrtype_id", self.corrtype_id)
        _w.write_json("cfg", self.cfg)
        _w.write_datetime("tm_stamp", self.tm_stamp)
        _w.write_end(_oname)

    def _deserialize(self, _r: mettle.io.IReader, _oname: str = None):
        """
        Deserialize record from a stream.

        :param _r:
        :param _oname:
        """
        if _oname == None:
            _oname = self._name()

        _r.read_start(_oname)
        self.corrprov_id = _r.read_string("corrprov_id")
        self.corrtype_id = _r.read_string("corrtype_id")
        self.cfg = _r.read_json("cfg")
        self.tm_stamp = _r.read_datetime("tm_stamp")
        _r.read_end(_oname)

    def _copy_from(self, rec: "oCorrProvForService"):
        """
        Copies the column from the rec into this record.

        :param rec: The source record.
        """
        self.corrprov_id = rec.corrprov_id
        self.corrtype_id = rec.corrtype_id
        self.cfg = rec.cfg
        self.tm_stamp = rec.tm_stamp

    def __repr__(self) -> str:
        return '<CorrProv [corrprov_id:%.32s, corrtype_id:%.32s, cfg:%.32s, tm_stamp:%s]>' % (
            self.corrprov_id, self.corrtype_id, self.cfg, self.tm_stamp)


    class List(list, mettle.io.ISerializable):
        """
        List Class
        """

        def _name(self) -> str:
            """
            Name of the list.

            :return: The name
            """
            return 'oCorrProvForService.List'

        def _serialize(self, _w: mettle.io.IWriter, _oname: str = None):
            """
            Serialize the list to a stream.

            :param _w:
            :param _oname:
            """
            if _oname == None:
                _oname = self._name()

            _w.write_start_list(_oname, len(self))

            for _rec in self:
                _rec._serialize(_w)

            _w.write_end(_oname)

        def _deserialize(self, _r: mettle.io.IReader, _oname: str = None):
            """
            Deserialize the list from a stream.

            :param _r:
            :param _oname:
            """
            if _oname == None:
                _oname = self._name()

            _cnt = _r.read_start_list(_oname)

            while _cnt >= 1:
                _rec  = oCorrProvForService()
                _cnt -= 1
                _rec._deserialize(_r)
                self.append(_rec)

            _r.read_end(_oname)

        def __repr__(self) -> str:
            return '<oCorrProvForService.List[%d]>' % (len(self))

